// Auto-generated code will include this file.
#ifndef VERILATOR_MODEL_H
#define VERILATOR_MODEL_H

#include "model.h"
#include <iostream>
#include <memory>
#include <string>
#include <verilated.h>
#include <verilated_fst_c.h>
// #include <verilated_vcd_c.h>

namespace abies
{
template <class VMODEL> class VerilatorModel : public Model
{
  public:
    std::unique_ptr<VMODEL> top = std::make_unique<VMODEL>();

    VerilatorModel()
    {
        top->eval(); // Needed ?
    }

    void reset(int cycles)
    {
        top->rst = 1;
        for (int i = 0; i < cycles; i++)
        {
            top->clk = 1;
            top->eval();
            top->clk = 0;
            top->eval();
        }
        top->rst = 0;
    }

    int process(int32_t *idata, int ilen, int32_t *odata, int olen, int clk_div)
    {
        int odata_ctr = 0;

        for (int i = 0; i < ilen; i++)
        {
            top->valid_i = 1;
            top->data_i = idata[i];

            for (int j = 0; j < clk_div; j++)
            {
                top->clk = 1;
                top->eval();
                if (top->valid_o)
                {
                    odata[odata_ctr++] = top->data_o;
                }
                top->clk = 0;
                top->eval();
                top->valid_i = 0;
            }
        }
        // Flush
        while (odata_ctr < ilen)
        {
            // timeout?
            top->clk = 1;
            top->eval();
            if (top->valid_o)
            {
                odata[odata_ctr++] = top->data_o;
            }
            top->clk = 0;
            top->eval();
        }
        return 0;
    }
};
template <class VMODEL> class VerilatorModelTrace : public Model
{
  public:
    std::unique_ptr<VerilatedContext> contextp = std::make_unique<VerilatedContext>();
    std::unique_ptr<VerilatedFstC> trace = std::make_unique<VerilatedFstC>();
    std::unique_ptr<VMODEL> top;

    VerilatorModelTrace(const std::string &trace_path) : top(std::make_unique<VMODEL>(contextp.get()))
    {
        contextp->traceEverOn(true);
        // contextp->timeprecision(12);
        // contextp->timeunit(12);
        trace->set_time_resolution("ns");
        trace->set_time_unit("ns");

        top->trace(trace.get(), 99);
        trace->open(trace_path.c_str());
        top->eval();
    }

    void reset(int cycles)
    {
        top->rst = 1;
        for (int i = 0; i < cycles; i++)
        {
            top->clk = 1;
            top->eval();
            trace->dump(contextp->time());
            contextp->timeInc(5);
            top->clk = 0;
            top->eval();
            trace->dump(contextp->time());
            contextp->timeInc(5);
        }
        top->rst = 0;
    }

    int process(int32_t *idata, int ilen, int32_t *odata, int olen, int clk_div)
    {
        int odata_ctr = 0;

        for (int i = 0; i < ilen; i++)
        {
            top->valid_i = 1;
            top->data_i = idata[i];

            for (int j = 0; j < clk_div; j++)
            {
                top->clk = 1;
                top->eval();
                trace->dump(contextp->time());
                contextp->timeInc(5);

                if (top->valid_o)
                {
                    odata[odata_ctr++] = top->data_o;
                }
                top->clk = 0;
                top->eval();
                trace->dump(contextp->time());
                contextp->timeInc(5);
                top->valid_i = 0;
            }
        }
        // Flush
        while (odata_ctr < ilen)
        {
            // timeout?
            top->clk = 1;
            top->eval();
            trace->dump(contextp->time());
            contextp->timeInc(5);
            if (top->valid_o)
            {
                odata[odata_ctr++] = top->data_o;
            }
            top->clk = 0;
            top->eval();
            trace->dump(contextp->time());
            contextp->timeInc(5);
        }
        return 0;
    }
};
} // namespace abies

/*

}

*/
#endif