import numpy as np
from typing import Protocol
from abc import abstractmethod


class Model(Protocol):
    @abstractmethod
    def reset(self, cycles: int) -> None:
        raise NotImplementedError

    @abstractmethod
    def process(self, idata: np.ndarray, clk_div: int = 10) -> np.ndarray:
        raise NotImplementedError
