#include "${model_name}.h"
#include "model_api.h"
#include "verilator_model.h"

void *create_model(const char *trace_name)
{
    std::string trace_str(trace_name);
    if (!trace_str.empty())
    {
        return new abies::VerilatorModelTrace<${model_name}>(trace_name);
    }
    // Default, no trace.
    return new abies::VerilatorModel<${model_name}>();
}

void destroy_model(void *m)
{
    delete static_cast<abies::Model *>(m);
}

void reset_model(void *m_, int cycles)
{
    abies::Model *m = static_cast<abies::Model *>(m_);

    m->reset(cycles);
}

int process_model(void *m_, int32_t *idata, int ilen, int32_t *odata, int olen, int clk_div)
{
    abies::Model *m = static_cast<abies::Model *>(m_);
    return m->process(idata, ilen, odata, olen, clk_div);
}
