# from skbuild import setup
from setuptools import setup

with open("README.md", "r", encoding="utf-8") as fh:
    long_description = fh.read()

setup(
    name="abies",
    version="0.0.1",
    author="Frank Sodari",
    author_email="frank@abiesdsp.com",
    description="Abies audio processing framework.",
    long_description=long_description,
    long_description_content_type="text/markdown",
    url="https://github.com/AbiesDSP/Abies",
    classifiers=[
        "Programming Language :: Python :: 3",
        "License :: OSI Approved :: GNU General Public License v3 (GPLv3)",
        "Operating System :: OS Independent",
    ],
    packages=[
        "abies",
        "abies/simulator",
        "abies/simulator/c_include",
        "abies/templates",
    ],
    package_data={
        "abies/simulator/c_include": ["*.h"],
        "abies/templates": ["*"],
    },
    python_requires=">=3.9",
    install_requires=["numpy", "pyyaml", "sox", "soundfile"],
)
